import { OnInit, ElementRef, Renderer, EventEmitter, OnDestroy } from '@angular/core';
import { Subject } from 'rxjs/Subject';
import 'rxjs/add/observable/merge';
import 'rxjs/add/operator/map';
import 'rxjs/add/operator/mergeMap';
import 'rxjs/add/operator/takeUntil';
import 'rxjs/add/operator/takeLast';
import { DraggableHelper } from './draggableHelper.provider';
export declare type Coordinates = {
    x: number;
    y: number;
};
export declare type DragAxis = {
    x: boolean;
    y: boolean;
};
export declare type SnapGrid = {
    x?: number;
    y?: number;
};
export declare class Draggable implements OnInit, OnDestroy {
    element: ElementRef;
    private renderer;
    private draggableHelper;
    dropData: any;
    dragAxis: DragAxis;
    snapGrid: SnapGrid;
    ghostDragEnabled: boolean;
    dragStart: EventEmitter<Coordinates>;
    dragging: EventEmitter<Coordinates>;
    dragEnd: EventEmitter<Coordinates>;
    mouseDown: Subject<any>;
    mouseMove: Subject<any>;
    mouseUp: Subject<any>;
    constructor(element: ElementRef, renderer: Renderer, draggableHelper: DraggableHelper);
    ngOnInit(): void;
    ngOnDestroy(): void;
    /**
     * @private
     */
    onMouseDown(event: MouseEvent): void;
    /**
     * @private
     */
    onMouseMove(event: MouseEvent): void;
    /**
     * @private
     */
    onMouseUp(event: MouseEvent): void;
    private setCssTransform(value);
}
